;-=-=-=-=-=-=-=-=-=-=-=-=
;|82->83 Include File
;|Made by Sam Heald
;-=-=-=-=-=-=-=-=-=-=-=-=


#define equ .equ
#define EQU .equ
#define end .end

.org     9327h

;----= Shell Description =----
 nop
 jr     ProgStart
.dw     $0000
.dw     ProgDesc
;-----------------------------

;----= 82->83 Memory Addresses =----
TEXT_MEM  = $80C9
TEXT_MEM2 = $858F
GRAPH_MEM = $8E29
APD_BUF   = $8265


KEY_0		= $8000
KEY_1		= $8001
KEY_2		= $8002
KEY_STAT	= $8004	
LAST_KEY	= $8006	
CONTRAST	= $8008	
CURSOR_ROW  = $800C
CURSOR_COL  = $800D
CURSOR_LET  = $800E
CURSOR_X    = $8252
CURSOR_Y    = $8253

;----= 82->83 ROM_Call's =----
#DEFINE ROM_CALL(ADDR)    call ADDR

CLEARLCD   = $4755

D_ZT_STR   = $470D
D_ZM_STR   = $4781
D_LM_STR   = $4785
D_HL_DECI  = $4709
M_CHARPUT  = $477D
TX_CHARPUT = $4705

CP_HL_DE   = $4004
LD_HL_MHL  = $4000
GET_KEY    = $4014
KEY_HAND   = $4CFE
DISP_GRAPH = $5164    
MUL_HL     = $4382
UNPACK_HL  = $4008
DISP_DELAY = $4066
_ILine     = $4AE4
_ipoint    = $4AE8
_grbufclr  = $515b

;-------------------------------------------------------------------------------
;FIND_PIXEL Routine, by Patrick Davidson [From Zkart3d 82]
;-------------------------------------------------------------------------------
FIND_PIXEL_DATA:
         .db      128,64,32,16,8,4,2,1
FIND_PIXEL:
        push     bc
	   push     de
         ld       a,b
         and      7
         ld       hl,FIND_PIXEL_DATA
         ld       e,a
         ld       d,0
         add      hl,de
         ld       e,(hl)            ; E = pixel mask
         ld       a,63
         sub      c
         ld       c,a
         add      a,a
         add      a,c               ; A = 3 * Y
         ld       l,a
         ld       h,0
         add      hl,hl
         add      hl,hl             ; HL = 12 * Y
         ld       a,b
         ld       b,0
         rrca
         rrca
         rrca
         and      15
         ld       c,a
         add      hl,bc
         ld       a,e               ; A = pixel mask
         pop      de
         pop      bc
         ret

;GET_KEY equates

G_NONE    = $00 ; NO KEY
G_TAN     = $16 ; TAN
G_XTO     = $28 ; x,T,theta|
G_DOWN    = $01 ; DOWN
G_VARS    = $17 ; VARS
G_ON      = $29 ; ON
G_LEFT    = $02 ; LEFT
G_PERIODE = $19 ; .
G_STO     = $2A ; STO>
G_RIGTH   = $03 ; RIGHT
G_RIGHT   = $03 ; RIGHT
G_2       = $1A ; 2
G_LN      = $2B ; LN
G_UP      = $04 ; UP
G_5       = $1B ; 5
G_LOG     = $2C ; LOG
G_ENTER   = $09 ; ENTER
G_8       = $1C ; 8
G_SQR     = $2D ; X^2
G_PLUS    = $0A ; +
G_LPARAN  = $1D ; (
G_INVERSE = $2E ; X^-1
G_MINUS   = $0B ; -
G_COS     = $1E ; COS
G_MATH    = $2F ; MATH
G_TIMES   = $0C ; *
G_PRGM    = $1F ; PRGM
G_ALPHA   = $30 ; ALPHA
G_DIV     = $0D ; /
G_STAT    = $20 ; STAT
G_GRAPH   = $31 ; GRAPH
G_POWER   = $0E ; ^
G_0       = $21 ; 0
G_TRACE   = $32 ; TRACE
G_CLEAR   = $0F ; CLEAR
G_1       = $22 ; 1
G_ZOOM    = $33 ; ZOOM
G_NEG     = $11 ; (-)
G_4       = $23 ; 4
G_WINDOW  = $34 ; WINDOW
G_3       = $12 ; 3
G_7       = $24 ; 7
G_YEDIT   = $35 ; Y=
G_6       = $13 ; 6
G_COMMA   = $25 ; ,
G_2nd     = $36 ; 2nd
G_9       = $14 ; 9
G_SIN     = $26 ; SIN
G_MODE    = $37 ; MODE
G_RPARAN  = $15 ; )
G_MATRIX  = $27 ; MATRIX
G_DEL     = $38 ; DEL

.end
END